Subject: Re: GSoC draft proposal: Line-level history browser

From: Jakub Narebski <[email-masked]>
Date: Tue, 23 Mar 2010 12:22:38 +0100

On Tue, 23 Mar 2010, Bo Yang wrote:

Please do not forget to include attribution line, like the one I have
added below:
 
> Jakub Narebski wrote:

> > The problem is when you are asking about tracking a subset of lines
> > that appear in postimage of a patch.  For example if we ask for
> > history of
> >
> >                  strbuf_addstr(&buf, extra_hdr.items[i].string);
> >
> > line, should we track history of
> >
> >          for (i = 0; i < extra_hdr.nr; i++) {
> >
> > line which appears in relevant diff chunk?  If not, how we should
> > detect which line in preimage (if any) corresponds to given line in
> > postimage?
> 
> If I understand correctly, that is as following.
> 
> @@ -1008,29 +1000,29 @@ int cmd_format_patch(int argc, const char
> **argv, const char *prefix)
>                add_signoff = xmemdupz(committer, endpos - committer + 1);
>        }
> 
> -       for (i = 0; i < extra_hdr_nr; i++) {
> -              strbuf_addstr(&buf, extra_hdr[i]);
> +       for (i = 0; i < extra_hdr.nr; i++) {
> +              strbuf_addstr(&buf, extra_hdr.items[i].string);
>                strbuf_addch(&buf, '\n');
>        }
> 
> Here, the user only ask for tracking the strbuf_addstr line. And we
> find the above diff hunk. I think we can then find what the line would
> be in the preimage using @@ -1008,29 +1000,29 @@.  The strbuf_addstr
> is located at
> 1000(the postimage start line number)
> +3(the context number)
> +1(the number of lines '+' before this line) in the postimage,
> and we can calculate its line number in the preimage by the same way
> 1008
> +3
> +1(the number of lines with '-' before this line).
> 
> How do you think about this method?

This would work with the simplest case, but not in more complicated
cases, like for example preimage and postimage with different size.

Take for example the following chunk (fragment):

diff --git a/run-command.c b/run-command.c
index 2feb493..3206d61 100644
--- a/run-command.c
+++ b/run-command.c
@@ -67,19 +67,21 @@ static int child_notifier = -1;
 
 static void notify_parent(void)
 {
-	write(child_notifier, "", 1);
+	ssize_t unused;
+	unused = write(child_notifier, "", 1);
 }
 
 static NORETURN void die_child(const char *err, va_list params)

If you follow ssize_t line, it is created.  If you follow line with
write, which is 2nd line in postimage, its previous version is 1st
line in preimage.

Another example would be reordering of lines, or reordering with
some change.

-- 
Jakub Narebski
Poland